## gfal2 2.0.0

=== CMakeLists.txt ===
## cmake build script for srm-ifce
project (gfal2)
cmake_minimum_required (VERSION 2.6)
message("cmake source dir : ${CMAKE_SOURCE_DIR}")
# build type
set(CMAKE_BUILD_TYPE RelWithDebInfo
	CACHE STRING "type of build")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
# load module
include(DefineInstallationPaths REQUIRED)
include(MacroCopyFile REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)

find_package(PkgConfig REQUIRED)

find_package(OpenMP REQUIRED)

#enable testing
INCLUDE(CTest)

#define PROJECT vars
set(PROJECT_NAME_MAIN "gfal2")
set(OUTPUT_NAME_MAIN "gfal2")

set(PROJECT_NAME_TRANSFER "gfal_transfer")
set(OUTPUT_NAME_TRANSFER "gfal_transfer")

set(PROJECT_NAME_LFC "plugin_lfc")
set(OUTPUT_NAME_LFC "gfal_plugin_lfc")

set(PROJECT_NAME_SRM "plugin_srm")
set(OUTPUT_NAME_SRM "gfal_plugin_srm")

set(PROJECT_NAME_RFIO "plugin_rfio")
set(OUTPUT_NAME_RFIO "gfal_plugin_rfio")

set(PROJECT_NAME_DCAP "plugin_dcap")
set(OUTPUT_NAME_DCAP "gfal_plugin_dcap")

set(PROJECT_NAME_GRIDFTP "plugin_gridftp")
set(OUTPUT_NAME_GRIDFTP "gfal_plugin_gridftp")

set(PROJECT_NAME_FILE "plugin_file")
set(OUTPUT_NAME_FILE "gfal_plugin_file")

set(VERSION_MAJOR 2)
set(VERSION_MINOR 0)
set(VERSION_PATCH 0)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})




# libs checks
SET(CGREEN_LIBRARIES "cgreen")

pkg_check_modules(GLIB2_PKG REQUIRED glib-2.0)
pkg_check_modules(GTHREAD2_PKG REQUIRED gthread-2.0)

pkg_check_modules(UUID_PKG REQUIRED uuid)

pkg_search_module(GLIBMM_PKG REQUIRED glibmm glibmm-2.6 glibmm-2.4)


# general parameters for configuration
add_definitions( -DGFAL_PLUGIN_DIR_DEFAULT="${PLUGIN_INSTALL_DIR}" )
add_definitions( -DGFAL_CONFIG_DIR_DEFAULT="${SYSCONF_INSTALL_DIR}" )


#install doc license
install(FILES "LICENSE" "README" "RELEASE-NOTES" "VERSION" "DESCRIPTION"
			DESTINATION ${DOC_INSTALL_DIR})
			
# install configuration files
FILE(GLOB lst_conf_files "${CMAKE_SOURCE_DIR}/dist/etc/gfal2.d/*")
install(FILES ${lst_conf_files}
			DESTINATION ${SYSCONF_INSTALL_DIR}/gfal2.d/)

add_subdirectory (doc)
add_subdirectory (src)
add_subdirectory (test)
add_subdirectory (testing)

=== src/CMakeLists.txt ===
## default set of build
SET(MAIN_CORE TRUE
	CACHE STRING "enable compilation of the main library")

SET(PLUGIN_LFC TRUE
	CACHE STRING "enable compilation of the lfc plugin")
SET(PLUGIN_SRM TRUE
	CACHE STRING "enable compilation of the srm plugin")
SET(PLUGIN_RFIO TRUE
	CACHE STRING "enable compilation of the RFIO plugin")
SET(PLUGIN_DCAP TRUE
	CACHE STRING "enable compilation of the DCAP plugin")

	
SET(IS_IFCE FALSE)
# subdir import
add_subdirectory(global)
add_subdirectory(config)
add_subdirectory(file)
add_subdirectory(externals/utils)
add_subdirectory(externals/g_config_manager)
add_subdirectory(fdesc)

## defaults sources
FILE(GLOB src_posix "posix/*.c")
FILE(GLOB src_common "common/*.c")
FILE(GLOB src_gsimplecache "externals/gsimplecache/*.c")
#version sources
FILE(GLOB src_version "version/*.c")
#define lfc sources
FILE(GLOB src_lfc "common/lfc/*.c")
#define srm sources
FILE(GLOB src_srm "common/srm/*.c")
#define rfio sources
FILE(GLOB src_rfio "common/rfio/*.c")
#define dcap sources
FILE(GLOB src_dcap "common/dcap/*.c")
#define libcpp source
FILE(GLOB src_libcpp "libcpp/*.cpp")
#define logger source
FILE(GLOB src_logger "logger/*.c")
#define exceptions source
FILE(GLOB src_exceptions "exceptions/*.cpp")

# global headers
SET(common_dir	"common/")
SET(posix_dir	"posix/")
SET(mds_dir	"common/mds/")
SET(global_dir	".")
SET(externals_dir	"externals/")


# gfal2 link and link dir
SET(gfal2_link "gfal2")

LIST(APPEND headers_main ${common_dir} ${posix_dir} ${global_dir} 
			${mds_dir}  ${externals_dir})

include_directories(${headers_main} ${GLIB2_PKG_INCLUDE_DIRS} 
						${GTHREAD2_PKG_INCLUDE_DIRS})
add_definitions( -DVERSION="${VERSION_STRING}" -Wall ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS} -D_LARGEFILE64_SOURCE)

## link to internal bdii system if IS_IFCE=false else to the is_interface
IF (IS_IFCE)

	SET(is_ifce_link	"is_ifce")
	add_definitions(-DMDS_BDII_EXTERNAL=1)
	SET(mds_source "common/mds/gfal_common_mds.c")

ELSE (IS_IFCE)
	add_definitions(-DMDS_BDII_EXTERNAL=0)
	FILE(GLOB mds_source "common/mds/*.c")
	SET(is_ifce_link	"ldap_r")
	
ENDIF(IS_IFCE)

LIST(APPEND main_libs ${src_posix} ${src_common} ${src_global} ${src_config}
         ${mds_source} ${src_uri} ${src_logger} ${src_g_shared_map}
         ${src_file} )


IF (MAIN_CORE)

	add_library(gfal2  SHARED ${main_libs} )
	target_link_libraries(gfal2	${UUID_PKG_LIBRARIES} "stdc++" ) # hotfix for libc TLS init bug in EPEL 5 
	target_link_libraries(gfal2 ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES} 
							${is_ifce_link}  "dl" )
	set_target_properties(gfal2	 	PROPERTIES
									VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
									SOVERSION ${VERSION_MAJOR}
									CLEAN_DIRECT_OUTPUT 1
									OUTPUT_NAME ${OUTPUT_NAME_MAIN}
	)
	add_PkgConfigFile_for_Library("gfal2.pc" gfal2 
										HEADER_DIRS "gfal2"
										DESCRIPTION "GFAL 2.0 pkgconfig file"
										REQUIRES "glib-2.0")	
	add_executable(gfal2_version ${src_version})
	target_link_libraries(gfal2_version "gfal2")


	install(TARGETS gfal2 gfal2_version
			RUNTIME       DESTINATION ${BIN_INSTALL_DIR}
			LIBRARY       DESTINATION ${LIB_INSTALL_DIR} )
			
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal2.pc DESTINATION ${PKGCONFIG_FILES_DIR})

	install(FILES "gfal_api.h" "gfal_plugins_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/ ) # install headers main

	install(FILES "logger/gfal_logger.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/logger ) # install headers posix

	install(FILES "posix/gfal_posix_api.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/posix ) # install headers posix

	install(FILES   "common/gfal_constants.h"
					"common/gfal_common_plugin_interface.h" 
					"common/gfal_prototypes.h"
					"common/gfal_common_plugin.h" 
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/common ) # install headers common

	FILE(GLOB l_examples "../testing/example/*.c")
	install(FILES ${l_examples}
			DESTINATION ${DOC_INSTALL_DIR}/examples/ ) # install examples 
			
	install(FILES 	"global/gfal_global.h"
			DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)

ENDIF (MAIN_CORE)



IF(PLUGIN_LFC)

find_package(LFC REQUIRED)
find_package(DPM REQUIRED)


# lfc headers
SET(lfc_dir "common/lfc/")
SET(lfc_headers_dir "${LFC_INCLUDE}/lfc/")
#lcgdm headers
SET(lcgdm_headers_dir "${DPM_INCLUDE}/lcgdm/")

add_definitions( -D_REENTRANT)
add_library(plugin_lfc  SHARED ${src_lfc} ${src_gsimplecache})

target_link_libraries(plugin_lfc ${gfal2_link} ${LFC_LIBRARIES} ${UUID_PKG_LIBRARIES} )
include_directories(${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR} ${UUID_PKG_INCLUDE_DIR})


set_target_properties(plugin_lfc	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_LFC}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_lfc
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/lfc/README_PLUGIN_LFC"
		DESTINATION ${DOC_INSTALL_DIR})	
	    
ENDIF(PLUGIN_LFC)


IF(PLUGIN_SRM)

pkg_check_modules(SRM_IFCE_PKG REQUIRED srm-ifce)

add_definitions( ${SRM_IFCE_PKG_CFLAGS} ${OpenMP_C_FLAGS} )
include_directories( ${SRM_IFCE_PKG_INCLUDE_DIR} ${OpenMP_INCLUDE_DIRS})

add_library(plugin_srm  SHARED ${src_srm} ${src_gsimplecache} ${src_uri} )
target_link_libraries(plugin_srm ${gfal2_link} ${SRM_IFCE_PKG_LIBRARIES} ${OpenMP_LIBRARIES} gomp gfal2_transfer)


set_target_properties(plugin_srm	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_SRM}
                                                                LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins
)

install(TARGETS		plugin_srm
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/srm/README_PLUGIN_SRM"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_SRM)


IF(PLUGIN_RFIO)

find_package(DPM REQUIRED)

add_library(plugin_rfio  SHARED ${src_rfio} ${src_gsimplecache} )

target_link_libraries(plugin_rfio ${gfal2_link} ${DPM_LIBRARIES} )
include_directories( ${DPM_INCLUDE_DIR} )
add_definitions( ${DPM_CFLAGS} )

set_target_properties(plugin_rfio	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_RFIO}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_rfio
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
  	
install(FILES  "common/rfio/README_PLUGIN_RFIO"
		DESTINATION ${DOC_INSTALL_DIR})	
		
ENDIF(PLUGIN_RFIO)



IF(PLUGIN_DCAP)

find_package(DCAP REQUIRED)

add_definitions( -D_REENTRANT)
add_library(plugin_dcap  SHARED ${src_dcap} ${src_gsimplecache} )

target_link_libraries(plugin_dcap ${gfal2_link} ${DCAP_LIBRARIES})
include_directories( ${DCAP_INCLUDE_DIR} )
add_definitions( ${DCAP_CFLAGS} )

set_target_properties(plugin_dcap	 	PROPERTIES
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_DCAP}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)

install(TARGETS		plugin_dcap
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )

install(FILES  "common/dcap/README_PLUGIN_DCAP"
		DESTINATION ${DOC_INSTALL_DIR})	

ENDIF(PLUGIN_DCAP)


add_subdirectory(transfer)                         
add_subdirectory(common/gridftp)    
add_subdirectory(common/srm/test)
add_subdirectory(common/file)

=== test/CMakeLists.txt ===
## src cmake build script for srm-ifce

## default set of build
SET(UNIT_TESTS FALSE
	CACHE STRING "enable compilation of unit tests")
SET(FUNCTIONAL_TESTS FALSE
	CACHE STRING "functional tests for gfal ")
	

#mock src
FILE(GLOB src_mock "mock/*.c")
SET(headers_mock "mock/")

include_directories( ${headers_mock} "." ${PROJECT_SOURCE_DIR}/src/externals)

link_directories (${PROJECT_BINARY_DIR}/src /)



add_subdirectory(functional/gfal2)   
add_subdirectory(functional/old)

=== src/global/CMakeLists.txt ===
## default set of build

## defaults sources
FILE(GLOB src_global_f "*.c" )
SET(src_global ${src_global_f} PARENT_SCOPE)

FILE(GLOB header_global "gfal_global.h")

install(FILES ${header_global} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/global)







add_subdirectory (test)

=== src/transfer/CMakeLists.txt ===
## default set of build
SET(MAIN_TRANSFER TRUE
	CACHE STRING "enable compilation of the transfer library")

## defaults sources
FILE(GLOB src_trans "*.cpp" )
FILE(GLOB src_libcpp "../libcpp/*.cpp")


# gfal2 link and link dir
SET(gfal2_link "gfal2")





IF (MAIN_TRANSFER)



	LIST(APPEND header_transfer "gfal_transfer.h" "gfal_transfer_types.h")

	include_directories( "../ " "../libcpp/" ${GLIB2_PKG_INCLUDE_DIRS} 
						${GTHREAD2_PKG_INCLUDE_DIRS}  ${GLIBMM_PKG_INCLUDE_DIRS})
	add_definitions( ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS} ${GLIBMM_PKG_CFLAGS})
	
        add_library(gfal2_transfer  SHARED ${src_trans} ${src_libcpp} ${src_exceptions} )
	target_link_libraries(gfal2_transfer ${GLIB2_PKG_LIBRARIES} ${GTHREAD2_PKG_LIBRARIES} 
							${UUID_PKG_LIBRARIES} ${gfal2_link}  ${GLIBMM_PKG_LIBRARIES} "dl")
	set_target_properties(gfal2_transfer	 	PROPERTIES
									LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
									VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
									SOVERSION ${VERSION_MAJOR}
									CLEAN_DIRECT_OUTPUT 1
									OUTPUT_NAME ${OUTPUT_NAME_TRANSFER}
	)
	add_PkgConfigFile_for_Library("gfal_transfer.pc" gfal2_transfer 
										HEADER_DIRS "gfal2"
										DESCRIPTION "gfal_transfer pkgconfig file"
										REQUIRES "gfal2")

	install(TARGETS gfal2_transfer
			LIBRARY       DESTINATION ${LIB_INSTALL_DIR} )
			
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gfal_transfer.pc DESTINATION ${PKGCONFIG_FILES_DIR})
	install(FILES ${header_transfer} DESTINATION ${INCLUDE_INSTALL_DIR}/gfal2/transfer)
	install(FILES "README_TRANSFER"
			DESTINATION ${DOC_INSTALL_DIR})
ENDIF  (MAIN_TRANSFER)


link_directories (${CMAKE_BINARY_DIR}/src) 
add_subdirectory (test)

=== src/common/file/CMakeLists.txt ===
#File plugin compilation file
SET(PLUGIN_FILE TRUE
	CACHE STRING "enable compilation of the local File plugin")

#define gridftp source
FILE(GLOB src_file "*.c*")




IF(PLUGIN_FILE)


add_library(plugin_file  SHARED ${src_file})

target_link_libraries(plugin_file ${gfal2_link}
			)


set_target_properties(plugin_file	 	PROPERTIES
								LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_FILE}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)



install(TARGETS		plugin_file
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
install(FILES		"README_PLUGIN_FILE"
		DESTINATION ${DOC_INSTALL_DIR})	    

ENDIF(PLUGIN_FILE)

link_directories (${CMAKE_BINARY_DIR}/plugins) 
link_directories (${CMAKE_BINARY_DIR}/src) 

add_subdirectory (test)

=== src/common/gridftp/CMakeLists.txt ===
#grid ftp plugin compilation file
SET(PLUGIN_GRIDFTP TRUE
	CACHE STRING "enable compilation of the GRIDFTP plugin")

#define gridftp source
FILE(GLOB src_gridftp "*.c*")




IF(PLUGIN_GRIDFTP)

pkg_check_modules(GLOBUS_GASS_COPY_PKG REQUIRED globus-gass-copy)

#FILE(GLOB gridFTP_scripts "../dist/scripts/gfal_plugin_dcap/*sh")

add_definitions( ${GLOBUS_GASS_COPY_PKG_CFLAGS}    ${OpenMP_C_FLAGS})
add_library(plugin_gridftp  SHARED ${src_gridftp} ${src_libcpp} ${src_exceptions})

target_link_libraries(plugin_gridftp ${gfal2_link}
			${GLOBUS_GASS_COPY_PKG_LIBRARIES} gfal2_transfer
                        gomp
			)
include_directories( ${GLOBUS_GASS_COPY_PKG_INCLUDE_DIRS}
				${GRIDFTP_IFCE_INCLUDE_DIRS} 	 
				${GLIBMM_PKG_INCLUDE_DIRS}
                                ${OpenMP_INCLUDE_DIRS}
				)


set_target_properties(plugin_gridftp	 	PROPERTIES
								LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/src
								CLEAN_DIRECT_OUTPUT 1
								OUTPUT_NAME ${OUTPUT_NAME_GRIDFTP}
								LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins								
)



install(TARGETS		plugin_gridftp
	    LIBRARY		DESTINATION ${PLUGIN_INSTALL_DIR} )
	    
install(FILES		"README_PLUGIN_GRIDFTP"
		DESTINATION ${DOC_INSTALL_DIR})	    
#install(FILES ${dcap_scripts} DESTINATION ${SYSCONF_INSTALL_DIR}/profile.d/ )

ENDIF(PLUGIN_GRIDFTP)

link_directories (${CMAKE_BINARY_DIR}/plugins) 
link_directories (${CMAKE_BINARY_DIR}/src) 

add_subdirectory (test)

=== src/transfer/test/CMakeLists.txt ===
#
# unti test for transfer system



IF (UNIT_TESTS )

IF (MAIN_TRANSFER)
	FILE(GLOB src_test_transfer "*.c*")

	add_executable(unit_test_transfer_params	${src_test_transfer} )
	
	target_link_libraries(unit_test_transfer_params ${OUTPUT_NAME_MAIN} ${CGREEN_LIBRARIES}  gfal2_transfer m)
	
	add_test(test_transfer_params unit_test_transfer_params create_params)
	add_test(test_transfer_params2 unit_test_transfer_params test_timeout)
	add_test(test_transfer_nbstream unit_test_transfer_params test_nbstreams)
	add_test(test_transfer_nbstream_c unit_test_transfer_params test_nbstreams_c)
	add_test(test_transfer_lock unit_test_transfer_params test_lock)
	add_test(test_transfer_params2_c unit_test_transfer_params test_timeout_c)
	add_test(test_transfer_filecopy_instance unit_test_transfer_params test_filecopy_instance)
	add_test(test_transfer_filecopy_instance_c unit_test_transfer_params test_filecopy_instance_c)
	add_test(test_transfer_filecopy_instance_prob unit_test_transfer_params test_filecopy_instance_c_problem)
	
ENDIF  (MAIN_TRANSFER)

ENDIF (UNIT_TESTS)

=== test/functional/gfal2/CMakeLists.txt ===
#
# compilation lines for examples

# lib test
FILE(GLOB src_lib_test "gfal_lib_test.c")

# list tests
FILE(GLOB src_gfalchecksum_test "gfal_testchecksum.c")
FILE(GLOB src_gfalstat "gfal_teststat.c")
FILE(GLOB src_gfal_testchmod "gfal_testchmod.c")
FILE(GLOB src_gfal_checksum_tool "gfal_checksum_tool.c")
FILE(GLOB src_gfalread "gfal_testread.c")
FILE(GLOB src_gfalwrite "gfal_testwrite.c")
FILE(GLOB src_gfalrw "gfal_testrw.c")
FILE(GLOB src_gfal_rw_full "gfal_testrw_full.c")
FILE(GLOB src_gfal_rw_seq "gfal_testrw_seq.c")
FILE(GLOB src_gfalget "gfal_testget.c")
FILE(GLOB src_gfaltestcreatedir "gfal_testcreatedir.c")
FILE(GLOB src_gfaltestrightchange "gfal_test_right_change.c")
FILE(GLOB src_gfaltestrmdirfull "gfal_test_rmdir_full.c")
FILE(GLOB src_test_readdir_full "gfal_test_readdir_full.c")
FILE(GLOB src_gfalmkdir_full "gfal_mkdir_full.c")
FILE(GLOB src_gfaltcopy "gfalt_copyfile.c")
FILE(GLOB src_gfaltcopy_test "gfalt_copyfile_test.c")
FILE(GLOB src_gfaltcopy_perf "gfalt_copyfile_with_performance_marker.c")
FILE(GLOB src_copyfile_replace "gfalt_copyfile_replace_test.c")
FILE(GLOB src_copyfile_checksum "gfalt_copyfile_checksum_test_simple.c")
FILE(GLOB src_copyfile_checksum_user "gfalt_copyfile_checksum_test_userdefined.c")

SET(COPY_SRC "*.sh")
SET(COPY_DST "${CMAKE_CURRENT_BINARY_DIR}/")

IF (FUNCTIONAL_TESTS)

  #  pkg_search_module(NETTLE_PKG REQUIRED nettle)

        include_directories( "${CMAKE_SOURCE_DIR}/src "  "${CMAKE_SOURCE_DIR}/src/posix/"
                    ${GLIB2_PKG_INCLUDE_DIRS} ${NETTLE_PKG_INCLUDE_DIRS} )

        add_executable(gfal_stat	${src_gfalstat} )
	target_link_libraries(gfal_stat ${OUTPUT_NAME_MAIN} )

   #     add_executable(gfal_checksum_test	${src_gfalchecksum_test} ${src_lib_test} )
    #    target_link_libraries(gfal_checksum_test ${OUTPUT_NAME_MAIN} ${NETTLE_PKG_LIBRARIES})

        add_executable(gfal_checksum_tool	${src_gfal_checksum_tool})
        target_link_libraries(gfal_checksum_tool ${OUTPUT_NAME_MAIN})
	
	FUNCTION(stat_test_all name valid)
		add_test(gfal_stat_${name} gfal_stat ${valid})
	ENDFUNCTION(stat_test_all valid)

        FUNCTION(checksum_test_all name valid)
       #         add_test(gfal_checksum_${name} gfal_checksum_test ${valid})
        ENDFUNCTION(checksum_test_all name valid)

        FUNCTION(checksum_test_simple name valid_file algo)
                add_test(gfal_checksum_simple_${name} gfal_checksum_tool ${valid_file} ${algo})
        ENDFUNCTION(checksum_test_simple name valid_file algo)
	
	FUNCTION(chmod_test_all name valid right1 right2 right3 right4)
		add_test(gfal_test_right_change_${name} gfal_test_right_change ${valid} ${right1} ${right2} ${right3} ${right4})
	ENDFUNCTION(chmod_test_all name valid right1 right2 right3 right4)	
	

	FUNCTION(rmdir_test_all name valid_dir valid_file)
		add_test(gfal_test_rmdir_full_${name} gfal_test_rmdir_full ${valid_dir} ${valid_file} )
	ENDFUNCTION(rmdir_test_all name valid right1 right2 right3 right4)	
	
	FUNCTION(test_readdir_full name valid)
		add_test(gfal_test_readdir_full_${name} gfal_test_readdir_full ${valid})
	ENDFUNCTION(test_readdir_full valid)	

	FUNCTION(rwt_test_all name path size)
		add_test(gfal_rw_size_${name} gfal_rw_full ${path} ${size})
	ENDFUNCTION(rwt_test_all name path size)
	
	FUNCTION(rwt_test_seq name path size size_read)
		add_test(gfal_rw_seq_${name} gfal_rw_seq ${path} ${size} ${size_read})		
	ENDFUNCTION(rwt_test_seq name path size size_read)
	
		
	add_executable(gfal_read	${src_gfalread} )
	target_link_libraries(gfal_read ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_write	${src_gfalwrite} )
	target_link_libraries(gfal_write ${OUTPUT_NAME_MAIN} )	

	add_executable(gfal_rw	${src_gfalrw} )
	target_link_libraries(gfal_rw ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_rw_full	${src_gfal_rw_full} )
	target_link_libraries(gfal_rw_full ${OUTPUT_NAME_MAIN} )	
	
	add_executable(gfal_rw_seq	${src_gfal_rw_seq} )
	target_link_libraries(gfal_rw_seq ${OUTPUT_NAME_MAIN} )		
	
	add_executable(gfal_testget	${src_gfalget} )
	target_link_libraries(gfal_testget ${OUTPUT_NAME_MAIN} )
	
	add_executable(gfal_testchmod	${src_gfal_testchmod} )
	target_link_libraries(gfal_testchmod ${OUTPUT_NAME_MAIN} )	

	add_executable(gfal_createdir	${src_gfaltestcreatedir} )
	target_link_libraries(gfal_createdir ${OUTPUT_NAME_MAIN} )
	

	add_executable(gfal_test_mkdir_full	${src_gfalmkdir_full} )
	target_link_libraries(gfal_test_mkdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})
	
	add_executable(gfal_test_right_change ${src_gfaltestrightchange})
	target_link_libraries(gfal_test_right_change ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})	
	
	add_executable(gfal_test_rmdir_full ${src_gfaltestrmdirfull})
	target_link_libraries(gfal_test_rmdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})	

	add_executable(gfal_test_readdir_full	${src_test_readdir_full} )
	target_link_libraries(gfal_test_readdir_full ${OUTPUT_NAME_MAIN} ${GLIB2_PKG_LIBRARIES})	
	

	FUNCTION(mkdir_test_all name prefix)
		add_test(gfal_mkdir_full_${name} gfal_test_mkdir_full ${prefix})
	ENDFUNCTION(mkdir_test_all name prefix)	
	
	IF (MAIN_TRANSFER)

		add_executable(gfal_copyfile ${src_gfaltcopy} )
		target_link_libraries(gfal_copyfile ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(gfal_copyfile_perf ${src_gfaltcopy_perf} )
                target_link_libraries(gfal_copyfile_perf ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
		
		add_executable(gfal_copyfile_test ${src_gfaltcopy_test} ${src_lib_test})
		target_link_libraries(gfal_copyfile_test ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})		
		
		add_executable(copyfile_replace ${src_copyfile_replace} ${src_lib_test})
		target_link_libraries(copyfile_replace ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(copyfile_checksum ${src_copyfile_checksum} ${src_lib_test})
                target_link_libraries(copyfile_checksum ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})

                add_executable(copyfile_checksum_user ${src_copyfile_checksum_user} ${src_lib_test})
                target_link_libraries(copyfile_checksum_user ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_MAIN})
		
#		copy_files(${COPY_SRC} ${COPY_DST})
#		add_test(functional_copyfile gfal2_copyfile.sh)
#		add_test(functional_copyfile_srm gfal2_copyfile_srm.sh)
		
	FUNCTION(copy_file_test_full name src_file dir_src)
                add_test(copyfile_checksum_${name} copyfile_checksum ${src_file} ${dir_src})
                add_test(copyfile_checksum_user_${name} copyfile_checksum_user ${src_file} ${dir_src})
		add_test(copyfile_replace_${name} copyfile_replace ${src_file} ${dir_src})
		add_test(copyfile_test_${name} gfal_copyfile_test ${src_file} ${dir_src})
	ENDFUNCTION(copy_file_test_full name dir_src)


        FUNCTION(copy_file_test_simple name src_file dir_src)
                add_test(copyfile_test_${name} gfal_copyfile_test ${src_file} ${dir_src})
        ENDFUNCTION(copy_file_test_simple name src_file dir_src)

        ENDIF (MAIN_TRANSFER)

	include(functional-test-parameters.cmake)	
	
ENDIF  (FUNCTIONAL_TESTS)

=== test/functional/old/CMakeLists.txt ===
## src cmake build script for srm-ifce

## default set of build

	
## defaults sources
FILE(GLOB src_test_global "*.c")
FILE(GLOB src_test_posix "posix/*.c")
FILE(GLOB src_test_common "common/*.c")
FILE(GLOB src_test_gsimplecache "externals/*.c")
FILE(GLOB src_gskiplist "${CMAKE_SOURCE_DIR}/src/externals/gskiplist/*.c")


#define lfc sources
FILE(GLOB src_test_lfc "common/lfc/*.c")
#define srm sources
FILE(GLOB src_test_srm "common/mds/*.c")
#define rfio sources
FILE(GLOB src_test_rfio "common/rfio/*.c")


LIST(APPEND src_tests_all ${src_test_global} ${src_test_posix} 
				${src_test_common} ${src_test_gsimplecache} ${src_mock} ${src_test_lfc} 
					${src_test_srm} ${src_test_rfio} ${src_gsimplecache} ${src_gskiplist})

# global headers
SET(src_dir	"${CMAKE_SOURCE_DIR}/src/")
SET(common_dir	"${CMAKE_SOURCE_DIR}/src/common/")
SET(posix_dir	"${CMAKE_SOURCE_DIR}/src/posix/")
SET(mds_dir	"${CMAKE_SOURCE_DIR}/src/common/mds/")
SET(global_dir	".")




IF (FUNCTIONAL_TESTS)

	find_package(LFC REQUIRED)
	find_package(DPM REQUIRED)

	include_directories( ${GLIB2_PKG_INCLUDE_DIRS} 
						${GTHREAD2_PKG_INCLUDE_DIRS} ${common_dir} ${posix_dir} ${global_dir} ${src_dir})
						
    #include lfc
 	include_directories(   ${LFC_INCLUDE_DIR} ${LCGDM_INCLUDE_DIR}	)
 	
 	link_directories( "${CMAKE_CURRENT_BINARY_DIR}/../src/" "${CMAKE_BINARY_DIR}/plugins/")	
 						
	add_definitions( -Wall ${GLIB2_PKG_CFLAGS} ${GTHREAD2_PKG_CFLAGS} -D_LARGEFILE64_SOURCE -D_REENTRANT)
	## unit tests
	add_executable(test_all_with_mock	${src_tests_all} )
	target_link_libraries(test_all_with_mock ${OUTPUT_NAME_MAIN} ${CGREEN_LIBRARIES} m )
	
	#target link lfc
	target_link_libraries(test_all_with_mock ${OUTPUT_NAME_LFC})	
	#target link srm
	target_link_libraries(test_all_with_mock ${OUTPUT_NAME_SRM})		
	# target link rfio 
	target_link_libraries(test_all_with_mock ${OUTPUT_NAME_RFIO})
	
	
#env_test.PrependENVPath('LCG_GFAL_INFOSYS', lfc_gfal_infosys); # setup the bdii access point
#env_test.PrependENVPath('LFC_HOST', lfc_host); # setup the bdii access point
#env_test.PrependENVPath('GFAL_PLUGIN_LIST', "libgfal_plugin_lfc.so:libgfal_plugin_srm.so:libgfal_plugin_rfio.so"); # setup the GFAL PLUGIN SEARCH PATH

	add_test(test-all test_all_with_mock)
ENDIF (FUNCTIONAL_TESTS)

=== src/common/gridftp/test/CMakeLists.txt ===
#
# unit test for transfer system



IF (UNIT_TESTS )

IF (PLUGIN_GRIDFTP)
	FILE(GLOB src_test_gridftp "*.c*")

	add_executable(unit_test_gridftp_plugin	${src_test_gridftp} )
	
	target_link_libraries(unit_test_gridftp_plugin ${OUTPUT_NAME_MAIN} ${CGREEN_LIBRARIES}  ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_GRIDFTP} m)
	
	add_test(test_gridftp_instance unit_test_gridftp_plugin load_gridftp)
	add_test(test_gridftp_handle unit_test_gridftp_plugin handle_creation)
	add_test(test_gridftp_URL unit_test_gridftp_plugin gridftp_parseURL)

	
ENDIF  (PLUGIN_GRIDFTP)

ENDIF (UNIT_TESTS)

=== src/common/srm/test/CMakeLists.txt ===
#
# unti test for transfer system

link_directories (${CMAKE_BINARY_DIR}/plugins) 
link_directories (${CMAKE_BINARY_DIR}/src) 

IF (UNIT_TESTS )

IF (PLUGIN_SRM)
	FILE(GLOB src_test_srm "*.c*")

	link_directories (${PROJECT_BINARY_DIR}/src) 
	add_executable(unit_test_srm_plugin	${src_test_srm} )
	
	target_link_libraries(unit_test_srm_plugin ${OUTPUT_NAME_MAIN} ${CGREEN_LIBRARIES}  ${OUTPUT_NAME_TRANSFER} ${OUTPUT_NAME_SRM} m)
	
	add_test(test_srm_check_url unit_test_srm_plugin srm_url_check)


	
ENDIF  (PLUGIN_SRM)

ENDIF (UNIT_TESTS)

=== debian/changelog ===
gfal2 (2.0.0-1) unstable; urgency=low

  * Initial release (Closes: #687682)

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Thu, 13 Sep 2012 16:32:12 +0200

=== debian/control ===
Source: gfal2
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@fysast.uu.se>
Build-Depends: debhelper (>= 8.0.0), cmake, doxygen, libglib2.0-dev, libglibmm-2.4-dev, libattr1-dev, libldap2-dev, uuid-dev, liblfc-dev, libdpm-dev, srm-ifce-dev, dcap-dev, libglobus-gass-copy-dev, pkg-config
Standards-Version: 3.9.3
Section: net
Homepage: https://svnweb.cern.ch/trac/lcgutil/wiki/gfal2

Package: gfal2
Architecture: any
Depends:  libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gfal2-plugin-lfc (= ${binary:Version}), gfal2-plugin-rfio (= ${binary:Version}), gfal2-plugin-dcap (= ${binary:Version}), gfal2-plugin-srm (= ${binary:Version}), gfal2-plugin-gridftp (= ${binary:Version})
Description: Grid file access library 2.0
 GFAL 2.0 offers an a single and simple POSIX-like API for the file
 operations in grids and cloud environments. The set of supported
 protocols depends on the gfal2 plugins install.

Package: libgfal2-2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core of the Grid File access Library 2.0
 The main library of gfal2. The gfal protocol support relies on a
 plugin system.

Package: libgfal-transfer2
Section: libs
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: File Transfer logic of gfal2
 gfal-transfer is the high level API for file transfer operations in
 gfal2. Transfer monitoring and third party transfers are supported.

Package: libgfal2-dev
Section: libdevel
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), libgfal-transfer2 (= ${binary:Version}), libglib2.0-dev, libattr1-dev, ${misc:Depends}
Description: Development files of gfal2
 Development files for gfal2

Package: gfal2-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for gfal2
 Documentation, doxygen and examples of gfal2.

Package: gfal2-plugin-lfc
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the lfc access for gfal2
 Provide the lfc support (LFN://) for gfal2. The LFC plugin allows
 read-only POSIX operations for the LFC catalog.

Package: gfal2-plugin-rfio
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the rfio access for gfal2
 Provide the rfio support (RFIO://) for gfal2. The rfio plugin
 provides the POSIX operations for the rfio URLs, the rfio protocol is
 used on the DPM and on the Castor storage systems.

Package: gfal2-plugin-dcap
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), dcap-tunnel-gsi, ${shlibs:Depends}, ${misc:Depends}
Description: Provide the dcap access for gfal2
 Provide the dcap support (GSIDCAP://, DCAP://) for gfal2. The dcap
 plugin provides the POSIX operations for the dcap URLs, the dcap
 protocol is used on the DCACHE storage system

Package: gfal2-plugin-srm
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the srm access for gfal2
 Provide the srm support (SRM://) for gfal2. The srm plugin provides
 the POSIX operations and the third party transfer support on the SRM
 URLs.

Package: gfal2-plugin-gridftp
Architecture: any
Depends: libgfal2-2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Provide the gridftp access for gfal2
 Provide the gridftp support (GSIFTP://) for gfal2. The gridftp plugin
 provides the POSIX operations and the third party transfer support on
 the GSIFTP URLs.
